'////////////////////////////////////////////////////////////////////////////////////////
'////////////////////////////////////////////////////////////////////////////////////////
'/////////                                                                      /////////
'///////// Piotr "JamP" Jamrozik                                                /////////
'/////////           OBSUGA PASTYLEK DALLAS DS1990A DLA PROCESORW 51          /////////
'/////////                       Z WYLICZANIEM SUMY CRC                         /////////
'/////////                                                                      /////////
'////////////////////////////////////////////////////////////////////////////////////////
'////////////////////////////////////////////////////////////////////////////////////////

$regfile = "89S8252.DAT"        'Definicja pliku procesora
'$large                          'Model adresowania pamici
$crystal = 11059200             'Czstotliwo generatora procesora
Config Lcd = 20 * 4             'Typ wywietlacza LCD
Config Lcdbus = 4               'Magistrala LCD 4 bity
Config Lcdpin = Pin , Db4 = P2.3 , Db5 = P2.2 , Db6 = P2.1 , Db7 = P2.0 , E = P2.4 , Rs = P2.5       'Definicja wyprowadze LCD
Deflcdchar 0 , 12 , 6 , 18 , 3 , 3 , 18 , 6 , 12       'Umiechnita buka :)
Dim Ar(8) As Byte               'Tablica danych klucza DS1990
Config 1wire = P2.6             'Definicja portu dla magistrali 1wire

Dim I As Byte                   'Licznik ptli
Dim Crc As Byte                 'Suma CRC
Dim Crcp As Byte                'Zmienna pomocnicza dla CRC

'////////////////////////////
'/////  START PROCEDUR  /////
'////////////////////////////
Cursor Off Noblink
Cls
Lcd "   CZYTNIK DS1990   "
'----------
Do
Call O1990                      'Skok do obslugi pastylki DS1990
Loop
'----------
'///////////////////////////////////////////////////////////
'///// PROCEDURA ODCZYTU I WYWIETLANIA KODU Z DS 1990A ////
'///////////////////////////////////////////////////////////
Sub O1990
Waitms 50
1wreset
   If Err = 1 Then
      Return
   Else
      1wwrite &H33
         For I = 1 To 8
            Ar(i) = 1wread()
         Next I
         Call Crc1990           'Skok do procedury wyliczajcej CRC
            If Crc <> Ar(8) Then       'Kontrole poprawnoci sum CRC z DS1990
            Elseif Crc = 0 Then
            Elseif Ar(8) = 0 Then
            Elseif Crc = 255 Then
            Elseif Ar(8) = 255 Then
            Else                'Gdy nie wykryto bldnego odczytu pastylki
               Locate 3 , 1     'zostanie wywietlony numer wraz z sum
               Lcdhex Ar(8)     'kontroln CRC i numerem serii pastylki
               Locate 3 , 11    'DS1990
               Lcdhex Ar(1)
               Locate 4 , 1
               Lcdhex Ar(7) ; Ar(6) ; Ar(5) ; Ar(4) ; Ar(3) ; Ar(2)
               Call Pastylkaok       'Tu wstaw swoj procedur obslugi
            End If
   End If
End Sub
'//////////////////////////////////////////////////////////////////////////////
Sub Crc1990                     'Procedura wyliczania CRC dla DS1990
Crc = 0
    For I = 1 To 7
       Crcp = Crc Xor Ar(i)
       Crc = Lookup(crcp , Crc8)
    Next
End Sub
'//////////////////////////////////////////////////////////////////////////////
Sub Pastylkaok                  'Procedura Obslugi pastylki
Locate 2 , 1
Lcd Chr(0)
End Sub
'//////////////////////////////////////////////////////////////////////////////
'Tablica do wyliczania CRC dla DS1990
Crc8:
Data 0 , 94 , 188 , 226 , 97 , 63 , 221 , 131 , 194 , 156
Data 126 , 32 , 163 , 253 , 31 , 65 , 157 , 195 , 33 , 127
Data 252 , 162 , 64 , 30 , 95 , 1 , 227 , 189 , 62 , 96
Data 130 , 220 , 35 , 125 , 159 , 193 , 66 , 28 , 254 , 160
Data 225 , 191 , 93 , 3 , 128 , 222 , 60 , 98 , 190 , 224
Data 2 , 92 , 223 , 129 , 99 , 61 , 124 , 34 , 192 , 158
Data 29 , 67 , 161 , 255 , 70 , 24 , 250 , 164 , 39 , 121
Data 155 , 197 , 132 , 218 , 56 , 102 , 229 , 187 , 89 , 7
Data 219 , 133 , 103 , 57 , 186 , 228 , 6 , 88 , 25 , 71
Data 165 , 251 , 120 , 38 , 196 , 154 , 101 , 59 , 217 , 135
Data 4 , 90 , 184 , 230 , 167 , 249 , 27 , 69 , 198 , 152
Data 122 , 36 , 248 , 166 , 68 , 26 , 153 , 199 , 37 , 123
Data 58 , 100 , 134 , 216 , 91 , 5 , 231 , 185 , 140 , 210
Data 48 , 110 , 237 , 179 , 81 , 15 , 78 , 16 , 242 , 172
Data 47 , 113 , 147 , 205 , 17 , 79 , 173 , 243 , 112 , 46
Data 204 , 146 , 211 , 141 , 111 , 49 , 178 , 236 , 14 , 80
Data 175 , 241 , 19 , 77 , 206 , 144 , 114 , 44 , 109 , 51
Data 209 , 143 , 12 , 82 , 176 , 238 , 50 , 108 , 142 , 208
Data 83 , 13 , 239 , 177 , 240 , 174 , 76 , 18 , 145 , 207
Data 45 , 115 , 202 , 148 , 118 , 40 , 171 , 245 , 23 , 73
Data 8 , 86 , 180 , 234 , 105 , 55 , 213 , 139 , 87 , 9
Data 235 , 181 , 54 , 104 , 138 , 212 , 149 , 203 , 41 , 119
Data 244 , 170 , 72 , 22 , 233 , 183 , 85 , 11 , 136 , 214
Data 52 , 106 , 43 , 117 , 151 , 201 , 74 , 20 , 246 , 168
Data 116 , 42 , 200 , 150 , 21 , 75 , 169 , 247 , 182 , 232
Data 10 , 84 , 215 , 137 , 107 , 53
'/////////////////////////////   KONIEC PROGRAMU   /////////////////////////////