/* USER CODE BEGIN Header */
/**
 ******************************************************************************
 * @file           : main.c
 * @brief          : Main program body
 ******************************************************************************
 * @attention
 *
 * Copyright (c) 2024 STMicroelectronics.
 * All rights reserved.
 *
 * This software is licensed under terms that can be found in the LICENSE file
 * in the root directory of this software component.
 * If no LICENSE file comes with this software, it is provided AS-IS.
 *
 ******************************************************************************
 */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"
#include "dma.h"
#include "iwdg.h"
#include "usart.h"
#include "gpio.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */

#include <string.h>
#include <stdio.h>
#include "../def.h"
#include "../ansi.h"
#include "../uarts/uarts.h"
#include "../onewire/onewire.h"
#include "../onewire/onewire_ds18b20.h"
#include <stdarg.h>		// va_start va_end


#define	TXT_ECHO_LEN		150

/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */
/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */

extern struct uarts_t uarts[];


void UART_Printf(const char *fmt, ...) {
	char buff[256];
	va_list args;


	va_start(args, fmt);
	//uint16_t comDbgLen =
	vsnprintf(buff, sizeof(buff), fmt, args);
	//	HAL_UART_Transmit(HUART_DBG, (uint8_t*) buff, strlen(buff), HAL_MAX_DELAY);
	va_end(args);

	sendUARTtxt(UART_DBG, buff);
	while( uarts[UART_DBG].FLtransitTx );
}


void initIrqTimSys(){
	LL_SYSTICK_EnableIT();	//  @paplociennik

	/*
	//SysTick_Config(SystemCoreClock/1000);
	//SysTick_Config(SysTick->LOAD);
	SysTick->CTRL |= SysTick_CTRL_TICKINT_Msk;
	NVIC_EnableIRQ(SysTick_IRQn);
	 */
}


uint64_t volatile timSYS;
uint16_t volatile timLED, timOW, timUARTtx, timUARTrx;
void irq1ms(){
	timSYS++;

	if ( timLED ) timLED--;
	if ( timUARTtx ) timUARTtx--;
	if ( timUARTrx ) timUARTrx--;
	if ( timOW ) timOW--;
}


dypedefResultDS18b20_t resDS18B20;


/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

	//----- Zatrzymuj IWDG podczas debugowania -----//

	// poniżesz podejrzane w HAL
	//SET_BIT(DBG->APBFZ1, DBG_APB_FZ1_DBG_IWDG_STOP);
	//__HAL_DBGMCU_FREEZE_IWDG(); DBGMCU -> APB1FZ |= DBGMCU_APB1_FZ_DBG_IWDG_STOP;


	//----- Nie rozlaczaj z debugerem po usypieniu, stop, itp
	//	  DBGMCU->CR |= DBGMCU_CR_DBG_SLEEP | DBGMCU_CR_DBG_STOP | DBGMCU_CR_DBG_STANDBY;   //

	/*
	  __HAL_DBGMCU_FREEZE_TIM1();
	  __HAL_DBGMCU_FREEZE_TIM2();
	  __HAL_DBGMCU_FREEZE_TIM3();
	  __HAL_DBGMCU_FREEZE_TIM4();
	 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART2_UART_Init();
  MX_DMA_Init();
  MX_USART1_UART_Init();
  MX_IWDG_Init();
  /* USER CODE BEGIN 2 */

	initIrqTimSys();
	//	setBaudUart(115200);
	initUartTX(1);
	initUartRX(1);

	setBaudUart(0, 115200);
	initUartTX(0);
	initUartRX(0);


	sendUARTtxt(UART_DBG, ANSI_CLS""ANSI_BOLD""ANSI_PEN_GREEN"12345-678"CRLF""ANSI_PEN_WHITE);

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
	while (1)  {
		LL_IWDG_ReloadCounter(IWDG);
		//__WFI();
		LL_GPIO_TogglePin(LOOP_GPIO_Port, LOOP_Pin);



		if( !timLED ){
			timLED = 800;

			LL_GPIO_TogglePin(LED_GREEN_GPIO_Port, LED_GREEN_Pin);
			//LL_mDelay(100);

		}

    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */


		if( ! timOW ){
			timOW = 800;

			extern dypedefResultDS18b20_t ResultDS18b20;
			if( ResultDS18b20.result ){
				char static txt[50];
				uint16_t t = ResultDS18b20.temp_i32 >> 4;
				uint16_t d = (ResultDS18b20.temp_i32 & 15) * 625;
				float temp_f =  ResultDS18b20.temp_i32 * 0.0625;

				sprintf(txt, ANSI_PEN_GREEN""CRLF"t=%.2f %d.%02d ", temp_f, t, d/100 );
				sendUARTtxt(UART_DBG, txt);
			}else{
				sendUARTtxt(UART_DBG, ANSI_PEN_RED""CRLF"DS18b20 Err");
			}
			TRAP;
			ds18b20_start_IT();
		}



#if UART_RX == 1
		while( LL_USART_IsActiveFlag_RXNE(uarts[1].USARTx) ){
			uarts[1].rx_buffer[uarts[1].rx_bufferCntWR] = LL_USART_ReceiveData8(uarts[1].USARTx);
			//			sendUARTtxt(UART_DBG, ".");
			timUARTrx = 1000;
			timUARTtx = DEF_TIM_UART_TX << 3;
			if ( uarts[1].rx_bufferCntWR < RX_UART_LEN ) uarts[1].rx_bufferCntWR++;
		}
		char static txtEcho[TXT_ECHO_LEN];
		if ( ! timUARTrx && uarts[1].rx_bufferCntWR ){
			uarts[1].rx_buffer[uarts[1].rx_bufferCntWR] = 0;
			snprintf(txtEcho, TXT_ECHO_LEN, CRLF""ANSI_PEN_CYAN"Echo: \"%s\""ANSI_PEN_WHITE, uarts[1].rx_buffer );
			sendUARTtxt(UART_DBG, txtEcho);
			uarts[1].rx_bufferCntWR = 0;
		}
#elif UART_RX == 2 || UART_RX == 3
#ifndef USARTRX_IDLE
		int16_t c;
		while( (c=GetUart(1)) != A_Duda ){
			timUARTtx = DEF_TIM_UART_TX << 3;
			char static txtEcho[TXT_ECHO_LEN];
			snprintf(txtEcho, TXT_ECHO_LEN, ANSI_PEN_CYAN"%c"ANSI_PEN_WHITE, c );
			sendUARTtxt(UART_DBG, txtEcho);
		}
#endif
#endif


		if( uarts[UART_DBG].FLrecirerIdle ){
			uarts[UART_DBG].FLrecirerIdle = false;

			uarts[UART_DBG].rx_buffer[uarts[UART_DBG].rx_bufferCntWR] = 0;		// znak końca stringu
			uarts[UART_DBG].rx_bufferCntWR = 0;
			char static txtEcho[TXT_ECHO_LEN];
			snprintf(txtEcho, TXT_ECHO_LEN, ANSI_PEN_CYAN"%s"ANSI_PEN_WHITE, uarts[UART_DBG].rx_buffer );
			sendUARTtxt(UART_DBG, txtEcho);
			timUARTtx = DEF_TIM_UART_TX << 3;
		}





		if( ! timUARTtx ) {
			timUARTtx = DEF_TIM_UART_TX;

			//			sendUARTtxt(0, "Test OneWire ");

#if UART_TX == 1
			sendUARTtxt(UART_DBG, ANSI_PEN_WHITE"Test.");
#elif UART_TX == 2
			sendUARTtxt(UART_DBG, ANSI_PEN_WHITE"Test IRQ.");
#elif UART_TX == 3
			sendUARTtxt(UART_DBG, ANSI_PEN_WHITE"Test DMA.");
#endif
		}

		/*
		if( uarts[0].FLrecirerIdle ){
			uarts[0].FLrecirerIdle = false;

			uarts[0].rx_buffer[uarts[0].rx_bufferCntWR] = 0;		// znak końca stringu
			uarts[0].rx_bufferCntWR = 0;
			char static txtEcho[TXT_ECHO_LEN];
			snprintf(txtEcho, TXT_ECHO_LEN, ANSI_PEN_MAGENTA"%s"ANSI_PEN_WHITE, uarts[0].rx_buffer );
			sendUARTtxt(UART_DBG, txtEcho);
		}
		 */



	}
  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI|RCC_OSCILLATORTYPE_LSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSIDiv = RCC_HSI_DIV1;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.LSIState = RCC_LSI_ON;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_NONE;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_HSI;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_0) != HAL_OK)
  {
    Error_Handler();
  }
}

/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
	/* User can add his own implementation to report the HAL error return state */
	__disable_irq();
	while (1)
	{
	}
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
	/* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
