/*
 * uarts.h
 *
 *  Created on: 28 gru 2023
 *      Author: Admin
 */

#ifndef SRC_UARTS_H_
#define SRC_UARTS_H_


#include "../def.h"



#define	L_UARTS			2
#define	UART_OW			0
#define	UART_DBG		1


#define	UART_TX			2		// 1-poling, 2-IRQ, 3-DMA
//#define	RS485				// Zmiana kierunku (RS485) odłączenie nadawania (RS422)

#define	UART_RX		2
#define	UARTRX_DMALEN	16
#define	USARTRX_IDLE
#define	RX_UART_LEN		100


#define	DEF_TIM_UART_TX		2000




struct uarts_t{
	uint16_t tx_len, DMArxLen, rx_bufferCntRD;
	uint16_t volatile rx_bufferCntWR;
	USART_TypeDef *USARTx;

	uint8_t *buf_tx_prt;
	char rx_buffer[RX_UART_LEN];

	uint8_t volatile FLtransitTx : 1;
	uint8_t volatile FLuartOVR : 1;
	uint8_t volatile FLrecirerIdle : 1;
};


int16_t GetUart(uint8_t com);
uint8_t sendUART(uint8_t com, uint8_t *txt, uint16_t len );
uint8_t sendUARTtxt(uint8_t com, char *txt );
void setBaudUart(uint8_t com, uint32_t baud);
void initUartTX(uint8_t com);
void initUartRX(uint8_t com);
void flushUartFifo(uint8_t com);


void irqUart2();
void irqUart1();
void irqUart(uint8_t com);

void enableDMArx();
void irqDmaUartTX();
void irqDmaUartRX();
void enableDMArx();




#endif /* SRC_UARTS_H_ */
